package pro.litvinovg.w2phtml.gui;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.UIManager;

import com.sun.star.uno.XComponentContext;

import pro.litvinovg.xml.Debug;

import java.awt.Toolkit;
import java.awt.GridLayout;
import javax.swing.JTabbedPane;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.GroupLayout.ParallelGroup;
import javax.swing.GroupLayout.SequentialGroup;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JRadioButton;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JSplitPane;
import java.awt.BorderLayout;
import javax.swing.JDesktopPane;
import javax.swing.BoxLayout;
import javax.swing.SpringLayout;
import java.awt.FlowLayout;
import java.awt.CardLayout;
import javax.swing.SwingConstants;

public class ConfigurationWindow extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static JFrame singleFrame = null;


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		runGUI(null);
	}

	private XComponentContext context;
	private JTextField tf_FilePath;

	/**
	 * Create the application.
	 */
	public ConfigurationWindow() {
		setTitle("Converter from ODT to HTML, ePub and RDF");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setIconImage(Toolkit.getDefaultToolkit().getImage(ConfigurationWindow.class.getResource("/pro/litvinovg/w2phtml/gui/resources/w2phtml.png")));
		initComponents();
		createEvents();
	}
	
	public ConfigurationWindow(XComponentContext context) {
		this.context = context;
		setTitle("Converter from ODT to HTML, ePub and RDF");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setIconImage(Toolkit.getDefaultToolkit().getImage(ConfigurationWindow.class.getResource("/pro/litvinovg/w2phtml/gui/resources/w2phtml.png")));
		initComponents();
		createEvents();
	}

	private void createEvents() {
		// TODO Auto-generated method stub
		
	}

	private void initComponents() {

		getContentPane().setLayout(new GridLayout(1, 0, 0, 0));

		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.LEFT);
		getContentPane().add(tabbedPane);

		//JPanel panel_rdf = createRDFPanel();
		//JPanel panel_epub = createEpubPanel(); 
		JPanel panel_html = createHTMLPanel();
		 
		
		tabbedPane.addTab("HTML", null, panel_html, null);
		//tabbedPane.addTab("RDF", null, panel_rdf, null);
		//tabbedPane.addTab("ePub", null, panel_epub, null);
		 
	}

	private JPanel createEpubPanel() {
		JPanel panel_epub = new JPanel();
		
		JPanel panel_control = createControlPanel(panel_epub);

		JPanel panel_configEpub = createConfigEpubPanel();

		applyDefaultLayout(panel_epub, panel_configEpub, panel_control);
		
		return panel_epub;
	}

	private JPanel createRDFPanel() {
		JPanel panel_rdf = new JPanel();
		
		JPanel panel_control = createControlPanel(panel_rdf);
		
		JPanel panel_configRDF = createConfigRDFPanel();

		applyDefaultLayout2(panel_rdf, panel_configRDF, panel_control);

		return panel_rdf;
	}

	private JPanel createHTMLPanel() {
		JPanel panel_html = new JPanel();

		JPanel panel_configHTML = createConfigHTMLPanel();

		JPanel panel_control = createControlPanel(panel_configHTML);

		applyDefaultLayout3(panel_html, panel_configHTML, panel_control);
		
		return panel_html;
	}

	private void applyDefaultLayout(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}
	private void applyDefaultLayout2(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}
	private void applyDefaultLayout3(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}

	private JPanel createConfigRDFPanel() {
		JPanel panel_configHTML = new JPanel();
		
		JCheckBox cb_UseMathJax = new JCheckBox("Use MathJax");

		JCheckBox cb_IgnoreEmptyParagraphs = new JCheckBox("Filter empty paragraphs");

		JCheckBox cb_IgnoreHardLineBreaks = new JCheckBox("Filter hard line breaks");

		JLabel lb_FilterLetterSpacing = new JLabel("Filter letter spacing less than");

		JTextField tf_FilterLetterSpacing = new JTextField();
		tf_FilterLetterSpacing.setColumns(10);

		JCheckBox cb_InlineStyles = new JCheckBox("Inline styles1");

		JCheckBox cb_EmbedVectorImages = new JCheckBox("Embed vector images");

		JCheckBox cb_EmbedRaster = new JCheckBox("Embed raster images");

		JLabel lb_MaxWidth_1 = new JLabel("Scale");

		JTextField tf_Scale = new JTextField();
		tf_Scale.setColumns(10);

		JCheckBox cb_ConversionToRem = new JCheckBox("Convert dimensions to REM");
		GroupLayout gl_panel_configHTML = new GroupLayout(panel_configHTML);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(40)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_MaxWidth_1, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 253, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_ConversionToRem, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE))
					.addContainerGap(332, Short.MAX_VALUE))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(38)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_MaxWidth_1))
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(31)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_FilterLetterSpacing))
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(2)
					.addComponent(cb_InlineStyles)
					.addGap(7)
					.addComponent(cb_EmbedVectorImages)
					.addGap(7)
					.addComponent(cb_EmbedRaster)
					.addGap(7)
					.addComponent(cb_ConversionToRem)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addGap(83)
					.addComponent(cb_UseMathJax)
					.addContainerGap(310, Short.MAX_VALUE))
		);
		panel_configHTML.setLayout(gl_panel_configHTML);
		return panel_configHTML;
	}
	
	private JPanel createConfigEpubPanel() {
		JPanel panel_configHTML = new JPanel();
		
		JCheckBox cb_UseMathJax = new JCheckBox("Use MathJax");

		JCheckBox cb_IgnoreEmptyParagraphs = new JCheckBox("Filter empty paragraphs");

		JCheckBox cb_IgnoreHardLineBreaks = new JCheckBox("Filter hard line breaks");

		JLabel lb_FilterLetterSpacing = new JLabel("Filter letter spacing less than");

		JTextField tf_FilterLetterSpacing = new JTextField();
		tf_FilterLetterSpacing.setColumns(10);

		JCheckBox cb_InlineStyles = new JCheckBox("Inline styles");

		JCheckBox cb_EmbedVectorImages = new JCheckBox("Embed vector images");

		JCheckBox cb_EmbedRaster = new JCheckBox("Embed raster images");

		JLabel lb_MaxWidth_1 = new JLabel("Scale");

		JTextField tf_Scale = new JTextField();
		tf_Scale.setColumns(10);

		JCheckBox cb_ConversionToRem = new JCheckBox("Convert dimensions to REM");
		GroupLayout gl_panel_configHTML = new GroupLayout(panel_configHTML);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(40)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_MaxWidth_1, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 253, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_ConversionToRem, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE))
					.addContainerGap(332, Short.MAX_VALUE))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(38)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_MaxWidth_1))
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(31)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_FilterLetterSpacing))
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(2)
					.addComponent(cb_InlineStyles)
					.addGap(7)
					.addComponent(cb_EmbedVectorImages)
					.addGap(7)
					.addComponent(cb_EmbedRaster)
					.addGap(7)
					.addComponent(cb_ConversionToRem)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addGap(83)
					.addComponent(cb_UseMathJax)
					.addContainerGap(310, Short.MAX_VALUE))
		);
		panel_configHTML.setLayout(gl_panel_configHTML);
		return panel_configHTML;
	}
	
	private JPanel createConfigHTMLPanel() {
		JPanel panel_configHTML = new JPanel();
		
		
		JCheckBox cb_UseMathJax = new JCheckBox("Use MathJax");

		JCheckBox cb_IgnoreEmptyParagraphs_2 = new JCheckBox("Split on whole pages only");

		JLabel lb_SplitByLevel = new JLabel("Split into multiple files by heading level");

		JTextField tf_SplitByLevel = new JTextField();
		tf_SplitByLevel.setColumns(10);

		JCheckBox cb_Greenstone = new JCheckBox("Split document into subsections for Greenstone digital library");

		JCheckBox cb_IgnoreEmptyParagraphs = new JCheckBox("Filter empty paragraphs");

		JCheckBox cb_IgnoreHardLineBreaks = new JCheckBox("Filter hard line breaks");

		JLabel lb_FilterLetterSpacing = new JLabel("Filter letter spacing less than");

		JTextField tf_FilterLetterSpacing = new JTextField();
		tf_FilterLetterSpacing.setColumns(10);

		JCheckBox cb_InlineStyles = new JCheckBox("Inline styles");

		JCheckBox cb_EmbedVectorImages = new JCheckBox("Embed vector images");

		JCheckBox cb_EmbedRaster = new JCheckBox("Embed raster images");

		JLabel lb_Scale = new JLabel("Scale");

		JTextField tf_Scale = new JTextField();
		tf_Scale.setColumns(10);

		JLabel lb_MaxWidth = new JLabel("Max body width");

		JTextField tf_MaxWidth = new JTextField();
		tf_MaxWidth.setColumns(10);

		JCheckBox cb_ConversionToRem = new JCheckBox("Convert dimensions to REM");
		
		JLabel lb_FilePath = new JLabel("File path");
		
		tf_FilePath = new JTextField();
		tf_FilePath.setColumns(10);
		GroupLayout gl_panel_configHTML = new GroupLayout(panel_configHTML);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(40)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_FilePath, GroupLayout.DEFAULT_SIZE, 755, Short.MAX_VALUE))
						.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_MaxWidth)
							.addGap(18)
							.addComponent(tf_MaxWidth, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 253, GroupLayout.PREFERRED_SIZE)
							.addGap(18)
							.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_ConversionToRem, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
						.addComponent(cb_Greenstone, GroupLayout.PREFERRED_SIZE, 482, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_SplitByLevel, GroupLayout.PREFERRED_SIZE, 295, GroupLayout.PREFERRED_SIZE)
							.addGap(42)
							.addComponent(tf_SplitByLevel, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
						.addComponent(cb_IgnoreEmptyParagraphs_2, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE))
					.addGap(40))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(17)
							.addComponent(lb_FilePath))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(15)
							.addComponent(tf_FilePath, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_Scale))
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(6)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_MaxWidth))
						.addComponent(tf_MaxWidth, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(6)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_FilterLetterSpacing))
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(2)
					.addComponent(cb_InlineStyles)
					.addGap(7)
					.addComponent(cb_EmbedVectorImages)
					.addGap(7)
					.addComponent(cb_EmbedRaster)
					.addGap(7)
					.addComponent(cb_ConversionToRem)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addGap(4)
					.addComponent(cb_Greenstone)
					.addGap(8)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addComponent(tf_SplitByLevel, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_SplitByLevel)))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreEmptyParagraphs_2)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addContainerGap(364, Short.MAX_VALUE))
		);
		panel_configHTML.setLayout(gl_panel_configHTML);
		return panel_configHTML;
	}

	private JPanel createControlPanel(JPanel configurationPanel) {
		JPanel controlPanel = new JPanel();
		
		JButton btn_Exit = new JButton("Exit");
		btn_Exit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				singleFrame.setVisible(false);
				singleFrame.dispose();
			}
		});
		
		JButton btn_SaveAs = new JButton("Save As");
		
		JButton btn_Save = new JButton("Save");
		
		JButton btn_Convert = new JButton("Convert");
		
		GroupLayout gl_panel_control = new GroupLayout(controlPanel);
		gl_panel_control.setHorizontalGroup(
			gl_panel_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_control.createSequentialGroup()
					.addGap(83)
					.addComponent(btn_Exit, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_SaveAs, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_Save, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_Convert, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addContainerGap(427, Short.MAX_VALUE))
		);
		gl_panel_control.setVerticalGroup(
			gl_panel_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_control.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_control.createParallelGroup(Alignment.BASELINE)
						.addComponent(btn_SaveAs)
						.addComponent(btn_Save)
						.addComponent(btn_Exit)
						.addComponent(btn_Convert))
					.addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
		);
						
		controlPanel.setLayout(gl_panel_control);
		return controlPanel;
	}

	public static void runGUI(XComponentContext context) {

		if (singleFrame != null) {
			singleFrame.dispose();
		}
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch (Throwable e) {
				String message = e.getLocalizedMessage();
				Debug.printLog(message, context);
			} 
			EventQueue.invokeLater(new Runnable() {
				public void run() {
					try {
						ConfigurationWindow frame = new ConfigurationWindow(context);
						singleFrame = frame;
						frame.setBounds(100, 100, 800, 800);
						frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
						frame.setVisible(true);

					} catch (Throwable e) {
						String message = e.getLocalizedMessage();
						
						Debug.printLog(message, context);
					} 
				}
			});	
		
	}
}
